diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFurnace.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFurnace.java
new file mode 100644
index 000000000..471d6f532
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFurnace.java
@@ -0,0 +1,36 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericFurnace<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel filled;
+
+    public BlockModelGenericFurnace(@NotNull Block<T> block, @NotNull String baseKey) {
+        super(block, BlockModelDispatcher.loadDataModel(baseKey));
+        this.filled = BlockModelDispatcher.loadDataModel(baseKey + "_filled").asModel();
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        if (source.getTileEntity(tilePosc) instanceof Container container) {
+            boolean hasOutput;
+            if (container instanceof TileEntityFurnaceBlast) {
+                hasOutput = container.getItem(3) != null;
+            } else {
+                hasOutput = container.getItem(2) != null;
+            }
+            if (hasOutput) {
+                return this.filled;
+            }
+        }
+        return super.getModel(source, tilePosc);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericJar.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericJar.java
new file mode 100644
index 000000000..138327f4e
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericJar.java
@@ -0,0 +1,20 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericJar<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel jarDirt = BlockModelDispatcher.loadDataModel("minecraft:block/jar_dirt").asModel();
+
+    public BlockModelGenericJar(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/jar"));
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return data == 1 ? this.jarDirt : super.getModelFromData(data);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLamp.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLamp.java
new file mode 100644
index 000000000..0f10c01a3
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLamp.java
@@ -0,0 +1,32 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericLamp<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel @NotNull [] models = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public final @NotNull StaticBlockModel @NotNull [] activeModels = new StaticBlockModel[DyeColor.COLOR_AMOUNT];
+    public BlockModelGenericLamp(@NotNull Block<T> block, @NotNull String baseKey, @NotNull String activeKey) {
+        super(block, BlockModelDispatcher.loadDataModel(String.format(baseKey, DyeColor.WHITE.colorID)));
+        for (DyeColor c : DyeColor.blockOrderedColors()) {
+            this.models[c.blockMeta] = BlockModelDispatcher.loadDataModel(String.format(baseKey, c.colorID)).asModel();
+            this.activeModels[c.blockMeta] = BlockModelDispatcher.loadDataModel(String.format(activeKey, c.colorID)).asModel();
+        }
+    }
+
+    @Override
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        this.activeModels[metadata & DyeColor.MASK_COLOR].renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLantern.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLantern.java
new file mode 100644
index 000000000..9da8f8995
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLantern.java
@@ -0,0 +1,22 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLanternFirefly;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericLantern<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel hangingModel;
+
+    public BlockModelGenericLantern(@NotNull Block<T> block, @NotNull final BlockModelData floorModel, @NotNull final BlockModelData hangingModel) {
+        super(block, floorModel);
+        this.hangingModel = hangingModel.asModel();
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return ((data & BlockLogicLanternFirefly.MASK_HANGING) != 0) ? this.hangingModel : super.getModelFromData(data);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
new file mode 100644
index 000000000..6bdc97a76
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLayer.java
@@ -0,0 +1,24 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLayerBase;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericLayer<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] models = new StaticBlockModel[7];
+    public BlockModelGenericLayer(@NotNull Block<T> block, @NotNull String basekey) {
+        super(block, BlockModelDispatcher.loadDataModel(basekey + "/0"));
+        for (int i = 0; i < this.models.length; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel(basekey + "/" + i).asModel();
+        }
+    }
+
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[(data & BlockLogicLayerBase.MASK_HEIGHT) % this.models.length];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
new file mode 100644
index 000000000..4d3887740
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
@@ -0,0 +1,42 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericLeaves<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public static boolean fancyGraphics;
+    public @NotNull StaticBlockModel fast;
+    public BlockModelGenericLeaves(@NotNull Block<T> block, @NotNull String key) {
+        super(block, BlockModelDispatcher.loadDataModel(key + "_fancy"));
+        this.fast = BlockModelDispatcher.loadDataModel(key + "_fast").asModel();
+    }
+
+    public static void setGraphicsLevel(boolean graphicsLevel) {
+        fancyGraphics = graphicsLevel;
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return fancyGraphics ? super.getModelFromData(data) : this.fast;
+    }
+
+    @Override
+    public boolean cullSide(@NotNull WorldSource worldSource, @NotNull TilePosc blockPos, @Nullable Direction direction) {
+        if (fancyGraphics) {
+            return super.cullSide(worldSource, blockPos, direction);
+        }
+        if (direction != null) {
+            TilePos shifted = blockPos.add(direction, new TilePos());
+            return worldSource.getBlock(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
+        }
+        return false;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCacao.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCacao.java
new file mode 100644
index 000000000..2e3af8e99
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCacao.java
@@ -0,0 +1,41 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLeavesCacao;
+import net.minecraft.core.block.BlockLogicLeavesCherryFlowering;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericLeavesCacao<T extends BlockLogic> extends BlockModelGenericLeaves<T> {
+    public @NotNull StaticBlockModel[] overlays = new StaticBlockModel[4];
+    public BlockModelGenericLeavesCacao(@NotNull Block<T> block) {
+        super(block, "minecraft:block/leaves/cacao");
+        for (int i = 0; i < this.overlays.length; i++) {
+            this.overlays[i] = BlockModelDispatcher.loadDataModel("minecraft:block/leaves/cacao_overlay_stage" + i).asModel();
+        }
+    }
+
+    @Override
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
+        this.overlays[this.overlays.length - 1].renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean didRender = super.renderAttached(tessellator, worldSource, tilePos, cullFaces, overrideTexture);
+        int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(worldSource.getBlockData(tilePos));
+        if (growthRate > 0) {
+            didRender |= this.overlays[Math.min(growthRate - 1, BlockLogicLeavesCacao.MAX_GROWTH_STATE - 1)].renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        return didRender;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCherryFlowering.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCherryFlowering.java
new file mode 100644
index 000000000..48c0959a6
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCherryFlowering.java
@@ -0,0 +1,42 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLeavesCherryFlowering;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericLeavesCherryFlowering<T extends BlockLogic> extends BlockModelGenericLeaves<T> {
+    public @NotNull StaticBlockModel overlay;
+    public @NotNull StaticBlockModel overlayFlowering;
+    public BlockModelGenericLeavesCherryFlowering(@NotNull Block<T> block) {
+        super(block, "minecraft:block/leaves/cherry");
+        this.overlay = BlockModelDispatcher.loadDataModel("minecraft:block/leaves/cherry_overlay").asModel();
+        this.overlayFlowering = BlockModelDispatcher.loadDataModel("minecraft:block/leaves/cherry_overlay_flowering").asModel();
+    }
+
+    @Override
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        super.renderStandalone(tessellator, metadata, lightmapCoord);
+        this.overlay.renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        boolean didRender = super.renderAttached(tessellator, worldSource, tilePos, cullFaces, overrideTexture);
+        int growthRate = BlockLogicLeavesCherryFlowering.getGrowthRate(worldSource.getBlockData(tilePos));
+        if (growthRate > 0) {
+            didRender |= this.overlay.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        } else {
+            didRender |= this.overlayFlowering.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+        }
+        return didRender;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLever.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLever.java
new file mode 100644
index 000000000..102f66c2f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLever.java
@@ -0,0 +1,45 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicLever;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericLever<T extends BlockLogic> extends BlockModelGeneric<T> {
+
+    public @NotNull StaticBlockModel active;
+    public BlockModelGenericLever(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/lever_idle"));
+        this.active = BlockModelDispatcher.loadDataModel("minecraft:block/lever_active").asModel();
+    }
+
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        int data = worldSource.getBlockData(tilePos);
+        int rotation = data & BlockLogicLever.MASK_ROTATION;
+        return switch (rotation) {
+            case BlockLogicLever.ROTATION_EAST -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicLever.ROTATION_WEST -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicLever.ROTATION_SOUTH -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicLever.ROTATION_NORTH -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicLever.ROTATION_TOP_NS -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicLever.ROTATION_TOP_WE -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicLever.ROTATION_BOTTOM_NS -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 2, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            case BlockLogicLever.ROTATION_BOTTOM_WE -> getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 2, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            default -> super.renderAttached(tessellator, worldSource, tilePos, cullFaces, overrideTexture);
+        };
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        boolean powered = (data & BlockLogicLever.MASK_POWERED) != 0;
+        return powered ? this.active : this.staticModel;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
new file mode 100644
index 000000000..a2f9296e2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericMatcher.java
@@ -0,0 +1,32 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+import java.util.Random;
+
+public class BlockModelGenericMatcher<T extends BlockLogic> extends BlockModelGenericAxis<T> {
+    public final @NotNull StaticBlockModel[] models = new StaticBlockModel[4];
+    public final Random random = new Random();
+    public BlockModelGenericMatcher(@NotNull Block<T> block, @NotNull String baseKey) {
+        super(block, BlockModelDispatcher.loadDataModel(baseKey + 0));
+        for (int i = 0; i < 4; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel(baseKey + i).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        this.random.setSeed(getPositionalSeed(tilePosc));
+        return this.models[this.random.nextInt(4)];
+    }
+
+    public long getPositionalSeed(@NotNull TilePosc tilePos) {
+        return tilePos.x() * 374761393L + tilePos.y() * 668265263L + tilePos.z() * 968290493L;
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPebbles.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPebbles.java
new file mode 100644
index 000000000..b0785263f
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPebbles.java
@@ -0,0 +1,22 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPebbles<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel[] models = new StaticBlockModel[3];
+    public BlockModelGenericPebbles(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/pebbles/0"));
+        for (int i = 0; i < 3; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/pebbles/" + i).asModel();
+        }
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data % 3];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPie.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPie.java
new file mode 100644
index 000000000..2afe5028a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPie.java
@@ -0,0 +1,23 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPie<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final StaticBlockModel[] models = new StaticBlockModel[4];
+    public BlockModelGenericPie(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/pumpkin_pie/0"));
+        for (int i = 0; i < this.models.length; i++) {
+            this.models[i] = BlockModelDispatcher.loadDataModel("minecraft:block/pumpkin_pie/" + i).asModel();
+        }
+    }
+
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return this.models[data % this.models.length];
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPiston.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPiston.java
new file mode 100644
index 000000000..df0372f54
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPiston.java
@@ -0,0 +1,53 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicVeryRotatable;
+import net.minecraft.core.block.piston.BlockLogicPistonBase;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPiston<T extends BlockLogic> extends BlockModelGenericVeryRotatable<T> {
+    public final @NotNull StaticBlockModel extended;
+    public BlockModelGenericPiston(@NotNull Block<T> block, @NotNull BlockModelData base, @NotNull BlockModelData extended) {
+        super(block, base);
+        this.extended = extended.asModel();
+    }
+
+    public boolean renderHeadless(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePos tilePos) {
+        final Direction dir = BlockLogicVeryRotatable.metaToDirection(worldSource.getBlockData(tilePos));
+        switch (dir) {
+            case UP -> {
+                return this.extended.renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, false, null);
+            }
+            case DOWN -> {
+                return this.extended.renderAttached(this, tessellator, worldSource, tilePos, -1, 0, 0, 0, 0, 0, false, false, null);
+            }
+            case NORTH -> {
+                return this.extended.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, false, null);
+            }
+            case SOUTH -> {
+                return this.extended.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, false, null);
+            }
+            case WEST -> {
+                return this.extended.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, false, null);
+            }
+            case EAST -> {
+                return this.extended.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, false, null);
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        boolean extended = /*noCulling || */(data & BlockLogicPistonBase.MASK_POWERED) != 0;
+//        Direction direction = BlockLogicPistonBase.getDirection(meta);
+        return extended ? this.extended : super.getModelFromData(data);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPistonHead.java
new file mode 100644
index 000000000..21092070a
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericPistonHead.java
@@ -0,0 +1,68 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicVeryRotatable;
+import net.minecraft.core.block.piston.BlockLogicPistonBase;
+import net.minecraft.core.block.piston.BlockLogicPistonHead;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.data.block.BlockModelData;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericPistonHead<T extends BlockLogic> extends BlockModelGenericVeryRotatable<T> {
+    public final @NotNull StaticBlockModel sticky;
+    public final @NotNull StaticBlockModel steel;
+    public final @NotNull StaticBlockModel baseHalf;
+    public final @NotNull StaticBlockModel stickyHalf;
+    public final @NotNull StaticBlockModel steelHalf;
+    public BlockModelGenericPistonHead(@NotNull Block<T> block, @NotNull BlockModelData piston, @NotNull BlockModelData sticky, @NotNull BlockModelData steel, @NotNull BlockModelData pistonHalf, @NotNull BlockModelData stickyHalf, @NotNull BlockModelData steelHalf) {
+        super(block, piston);
+        this.sticky = sticky.asModel();
+        this.steel = steel.asModel();
+        this.baseHalf = pistonHalf.asModel();
+        this.stickyHalf = stickyHalf.asModel();
+        this.steelHalf = steelHalf.asModel();
+    }
+    public void renderPistonHeadNoCulling(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, int meta, @NotNull TilePos tilePos, boolean flag) {
+        var model = switch (BlockLogicPistonHead.getPistonType(meta)) {
+            case BlockLogicPistonHead.TYPE_STICKY -> flag ? this.sticky : this.stickyHalf;
+            case BlockLogicPistonHead.TYPE_STEEL -> flag ? this.steel : this.steelHalf;
+            default -> flag ? this.staticModel : this.baseHalf;
+        };
+        final Direction dir = BlockLogicVeryRotatable.metaToDirection(worldSource.getBlockData(tilePos));
+        switch (dir) {
+            case UP -> {
+                model.renderAttached(this, tessellator, worldSource, tilePos, 1, 0, 0, 0, 0, 0, false, false, null);
+            }
+            case DOWN -> {
+                model.renderAttached(this, tessellator, worldSource, tilePos, -1, 0, 0, 0, 0, 0, false, false, null);
+            }
+            case NORTH -> {
+                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, false, null);
+            }
+            case SOUTH -> {
+                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, false, null);
+            }
+            case WEST -> {
+                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, false, null);
+            }
+            case EAST -> {
+                model.renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, false, null);
+            }
+        }
+    }
+
+
+    @Override
+    public @NotNull StaticBlockModel getModelFromData(int data) {
+        return switch (BlockLogicPistonHead.getPistonType(data)) {
+            case BlockLogicPistonHead.TYPE_STICKY -> this.sticky;
+            case BlockLogicPistonHead.TYPE_STEEL -> this.steel;
+            default -> this.staticModel;
+        };
+    }
+}
